state("mgs2_sse") {}

startup {
	vars.Reset = false;
}

init {
  	var module = modules.Where(x => x.ModuleName.Equals("MGS2.asi")).First();

  	print(string.Format("Attached to mgs2mods module ({0} bytes)", module.ModuleMemorySize));

	string signature = "42 4D 4E 44 41 54 41 2E 55 52 41 4D 45 53 2E 00";
	var sigTarget = new SigScanTarget(0, signature);
	var sigScanner = new SignatureScanner(game, module.BaseAddress, (int)module.ModuleMemorySize);
	IntPtr offset = sigScanner.Scan(sigTarget) + 16; // 16 = length of sig

	if (offset == IntPtr.Zero) {
		Thread.Sleep(3000);
		throw new NullReferenceException("Couldn't find You're Ames data, aborting");
	}

  	print("Found You're Ames struct at " + offset.ToString("X2"));

  	vars.M = new MemoryWatcherList() {
  		new MemoryWatcher<int>(offset) { Name = "Attempts" },
  		new MemoryWatcher<int>(offset + 4) { Name = "Found" },
  		new MemoryWatcher<byte>((IntPtr)0x118ADD0) { Name = "Difficulty" },
  	};

  	current.Difficulty = null;
  	current.Attempts = 0;
  	current.Found = 0;
}

update {
	vars.M.UpdateAll(game);

	if ((vars.M["Difficulty"].Changed) || (current.Difficulty == null)) {
		int diff = vars.M["Difficulty"].Current / 10;
		if (diff < 7) {
			current.Difficulty = new string[]{ "Unknown", "Very Easy", "Easy", "Normal", "Hard", "Extreme", "European Extreme" }[diff];
		}
	}
	current.Attempts = vars.M["Attempts"].Current;
	current.Found = vars.M["Found"].Current;
}

start {
	if (vars.Reset) {
		vars.Reset = false;
		return true;
	}	
	return vars.M["Attempts"].Changed;
}

reset {
	if (vars.M["Attempts"].Changed) {
		vars.Reset = true;
		return true;
	}
}

split {
	return (vars.M["Found"].Current == (vars.M["Found"].Old + 1));
}
